rizq_sanjaya_app/urls.py
from django.urls import path, include
from .views import *
from django.contrib.auth import views as auth_views


app_name = 'profile'
urlpatterns = [
    path('', dashboard.index, name='home'),
    path('calculate_loan', dashboard.calculate_loan, name='calculate_loan'),

    #INI ADALAH YOGYAEXPLORE
    path('profile/', dashboard.profil, name='profil'),
    path('paket/', dashboard.paket, name='paket'),
    path('detail_paket/<int:id>', dashboard.detail_paket, name='detail_paket'),
    path('cara_bayar/', dashboard.cara_bayar, name='cara_bayar'),
    path('gallery/', dashboard.galeri, name='galeri'),
    path('berita/', dashboard.beritaMobil, name='berita'),
    path('detail_info/<str:slug>', dashboard.detail_info, name='detail_info'),
    path('detail_mobil/<str:id>', dashboard.detail_mobil, name='detail_mobil'),
    path('promo/', dashboard.promo, name='promo'),
    path('pricelist/', dashboard.pricelist, name='pricelist'),
    path('category/<int:id>', dashboard.kategori, name='kategori'),
    path('detail_berita/<str:slug>', dashboard.detail_berita, name='detail_berita'),
    path('contact/', dashboard.kontak, name='kontak'),

    # path('gallery/', dashboard.gallery, name='gallerry'),
    path('prev/<int:id>/', dashboard.prev, name='prev'),
    path('next/<int:id>/', dashboard.next, name='next'),
    path('Category/', dashboard.ajax, name='ajax'),
    path('Produk/<int:id>', dashboard.produk, name='produk'),
    path('contact_us/', dashboard.contact, name='contact'),
    path('supplier/', dashboard.supplier, name='supplier'),
    path('render_laporan/', dashboard.render_laporan, name='render_laporan'),
    # url(r'refresh/$', views.captcha_refresh, name='captcha-refresh')
    # path('captcha/refresh/', guestbook.captcha_refresh, name='captcha_refresh'),

    # ABOUT ==================
    path('about/', halaman.index_about, name='idx_about'),
    
    # Mobil ==================
    path('kategori_mobil/<int:id_kat>', mobil_front.index, name='kategori_mobil'),

    # KONTAK PAJERO SPORT ==================
    path('contact/', halaman.index_contact, name='idx_contact'),

    # === Layanan ========================
    path('layanan/', layanan.index, name='layanan'),
    path('layanan/<str:jenis>', layanan.detail, name='layanan'),
    path('layanan/komoditas/<str:jenis>', layanan.detail_komoditas, name='detail_komoditas'),

    # DOKUMEN PUBLIKASI
    # path('dokumen/', documents.index, name='document'),
    # path('dokumen/<str:slug>', documents.detail, name='document_detail'),
    
    # NEWS ========================================
    path('berita/', news.index, name='news'),
    path('berita/<str:slug>', news.detail, name='news_detail'),
    path('berita/category/<str:jenis>/<str:slug>', news.category, name='news_by_category'),

    # DOKUMEN PUBLIKASI
    path('galeri/', gallery.index, name='gallery'),
    path('galeri/<str:slug>', gallery.detail, name='gallery_detail'),
    # path('galeri/category/<str:slug>', gallery.category, name='gallery_by_category'),

    # PAGES
    # path('profil/<str:slug>', pages.index, name='pages'),

    # AGENDA
    # path('agenda/', agenda.index, name='agenda'),
    # path('api/agenda/get', agenda.get_agenda, name='agenda_get'),
    # path('agenda/<str:slug>', agenda.get_agenda_detail, name='agenda_detail'),

    # BUKU TAMU
    # path('buku_tamu/', guestbook.index, name='guestbook'),

    # PENGADUAN
    # path('complaint/', complaint.index, name='complaint'),

    # PENGUMUMAN
    # path('pengumuman/', announcement.index, name='announcement'),
    # path('pengumuman/<str:slug>', announcement.detail_front, name='announcement_detail'),

    # TAGS
    path('tags/<str:jenis>/<str:slug>', tags.index, name='tags'),

    # PASSWORD
    # path("password_reset", user.password_reset_request, name="password_reset"),
    # path('password_reset/done/', auth_views.PasswordResetDoneView.as_view(template_name='profile/admin/user/password/password_reset_done.html'), name='password_reset_done'),
    # path('password/reset/<uidb64>/<token>/', auth_views.PasswordResetConfirmView.as_view(template_name="profile/admin/user/password/password_reset_confirm.html"), name='password_reset_confirm_custom'),

    # PATH URL UNTUK ADMIN 
    path('manage_panel/', include(
        [
            path('', admin.index, name='admin_home'),
            path('verification/', user.verification, name='admin_verification'),
            path('send_verification/', user.send_verification, name='admin_send_verification'),
            path('email/verify/<uidb64>/<token>/',user.email_verify, name='admin_email_verify'),

            # PRODUK =====================================
            path('product/', include(
                [
                    path('', product.admin_index, name='admin_product'),
                    path('add/', product.create, name='admin_product_create'),
                    path('edit/<str:slug>', product.edit, name='admin_product_edit'),
                    path('detail/<str:slug>', product.admin_detail, name='admin_product_detail'),
                    path('soft_delete/<str:slug>', product.softDelete, name='admin_product_soft_delete'),
                    path('permanent_delete/<str:slug>', product.permanentDelete, name='admin_product_permanent_delete'),
                    path('restore/<str:slug>', product.restore, name='admin_product_restore'),
                ]
            )),
            
            # NEWS BERITA
            path('news/', include(
                [
                    path('', news.admin_index, name='admin_news'),
                    path('create/', news.create, name='admin_news_create'),
                    path('edit/<str:slug>', news.edit, name='admin_news_edit'),
                    path('detail/<str:slug>', news.admin_detail, name='admin_news_detail'),
                    path('soft_delete/<str:slug>', news.softDelete, name='admin_news_soft_delete'),
                    path('permanent_delete/<str:slug>', news.permanentDelete, name='admin_news_permanent_delete'),
                    path('restore/<str:slug>', news.restore, name='admin_news_restore'),
                ]
            )),

            path('kata_mereka/', include(
                [
                    path('', kata.admin_index, name='admin_KM'),
                    path('create/', kata.create, name='admin_KM_create'),
                    path('edit/<int:id>', kata.edit, name='admin_KM_edit'),
                    path('detail/<int:id>', kata.admin_detail, name='admin_KM_detail'),
                    path('soft_delete/<int:id>', kata.softDelete, name='admin_KM_soft_delete'),
                    path('permanent_delete/<int:id>', kata.permanentDelete, name='admin_KM_permanent_delete'),
                    path('restore/<int:id>', kata.restore, name='admin_KM_restore'),
                ]
            )),
            path('Keunggulan/', include(
                [
                    path('', keunggulan.admin_index, name='admin_keunggulan'),
                    path('', keunggulan.admin_index, name='admin_keunggulan'),
                    path('create/', keunggulan.create, name='admin_keunggulan_create'),
                    path('edit/<int:id>', keunggulan.edit, name='admin_keunggulan_edit'),
                    path('detail/<int:id>', keunggulan.admin_detail, name='admin_keunggulan_detail'),
                    path('soft_delete/<int:id>', keunggulan.softDelete, name='admin_keunggulan_soft_delete'),
                    path('permanent_delete/<int:id>', keunggulan.permanentDelete, name='admin_keunggulan_permanent_delete'),
                    path('restore/<int:id>', keunggulan.restore, name='admin_keunggulan_restore'),
                ]
            )),
            path('kategori_mobil/', include(
                [
                    
                    path('', kategorimobil.admin_index, name='admin_kateogri_mobil'),
                    path('create/', kategorimobil.create, name='admin_kategorimobil_create'),
                    path('edit/<int:id>', kategorimobil.edit, name='admin_kategorimobil_edit'),
                    path('detail/<int:id>', kategorimobil.admin_detail, name='admin_kategorimobil_detail'),
                    path('soft_delete/<int:id>', kategorimobil.softDelete, name='admin_kategorimobil_soft_delete'),
                    path('permanent_delete/<int:id>', kategorimobil.permanentDelete, name='admin_kategorimobil_permanent_delete'),
                    path('restore/<int:id>', kategorimobil.restore, name='admin_kategorimobil_restore'),
                ]
            )),

            path('pricelist/', include(
                [
                    path('', pricelists.admin_index, name='admin_pricelist_mobil'),
                    path('create/', pricelists.create, name='admin_pricelist_create'),
                    path('edit/<int:id>/', pricelists.edit, name='admin_pricelist_edit'),
                    path('soft_delete/<int:id>', pricelists.softDelete, name='admin_pricelist_soft_delete'),
                    path('permanent_delete/<int:id>', pricelists.permanentDelete, name='admin_pricelist_permanent_delete'),
                    path('restore/<int:id>', pricelists.restore, name='admin_pricelist_restore'),
                ]
            )),

            path('mobil/', include(
                [
                    path('', mobil.admin_index, name='admin_mobil'),
                    path('create/', mobil.create, name='admin_mobil_create'),
                    path('edit/<int:id>', mobil.edit, name='admin_mobil_edit'),
                    path('detail/<int:id>', mobil.admin_detail, name='admin_mobil_detail'),
                    path('soft_delete/<int:id>', mobil.softDelete, name='admin_mobil_soft_delete'),
                    path('restore/<int:id>', mobil.restore, name='admin_mobil_restore'),
                    path('permanent_delete/<int:id>', mobil.permanentDelete, name='admin_mobil_delete'),
                    
                    path('child/', include(

toyotajogja/urls.py
from django.contrib import admin
from django.urls import path,include
from django.conf import settings
from django.conf.urls.static import static

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('rizq_sanjaya_app.urls')),
    path('accounts/', include("django.contrib.auth.urls")),
]
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

rizq_sanjaya_app/views/_complaint.py
from django.shortcuts import render, HttpResponse, HttpResponseRedirect, redirect
from django.contrib.auth.decorators import login_required
from django.views.decorators.http import require_http_methods
from ..forms import *
from django.contrib import messages
from ..models import Complaint
import os
from django.conf import settings
from django.core.mail import EmailMessage, get_connection
from django.template.loader import get_template
from django.utils import timezone
from ..decorators import *

@require_http_methods(["GET", "POST"])
def index(request):
    if request.method == 'GET':
        favorits = News.objects.filter(deleted_at=None).order_by('-seen')[:5]
        form = ComplaintForm()
        context = {
            'title' : 'Pengaduan',
            'form' : form,
            'favs' : favorits,
            'captcha' : MyCaptcha(),
        }

        return render(request, 'profile/complaint/index.html', context)
    
    if request.method == 'POST':
        form = ComplaintForm(data=request.POST)
        captcha = MyCaptcha(request.POST)

        if captcha.is_valid():
            if form.is_valid():
                try:
                    message = get_template("profile/email/complaint.html").render({
                        'name': request.POST.get('name'),
                        'email': request.POST.get('email'),
                        'phone': request.POST.get('phone'),
                        'subject': request.POST.get('subject'),
                        'message': request.POST.get('message'),
                    })
                    connection = get_connection(host=settings.EMAIL_HOST, 
                                                port=settings.EMAIL_PORT, 
                                                username=settings.EMAIL_HOST_USER_PENGADUAN, 
                                                password=settings.EMAIL_HOST_PASSWORD_PENGADUAN, 
                                                use_tls=settings.EMAIL_USE_TLS)
                    mail = EmailMessage(
                        subject=request.POST.get('subject'),
                        body=message,
                        to=[
                            # masih perlu diupdate
                            'yoelaris@gmail.com',
                        ],
                        connection=connection,
                    )
                    form.save()
                    
                    mail.content_subtype = "html"
                    mail.send()

                    messages.success(request, 'Pengaduan anda berhasil dikirim.')
                    
                except:
                    messages.success(request, 'Pengaduan anda gagal dikirim.')
                
                return redirect('profile:complaint')
        else:
            messages.error(request, 'Pengaduan anda gagal dikirim. Captcha tidak sama.')
            return redirect('profile:complaint')

        return render(request, 'profile/complaint/index.html', {'form': form})

@login_required
@is_verified()
@require_http_methods(["GET"])
def admin_index(request):
    complaint = Complaint.objects.filter(deleted_at = None).order_by('-created_at')
    archives = Complaint.objects.filter(deleted_at__isnull=False).order_by('-created_at')
    context = {
        'title' : 'Pengaduan - Admin',
        'complaints' : complaint,
        'archives' : archives,
    }
    
    return render(request, 'profile/admin/complaint/index.html', context)

@login_required
@is_verified()
@require_http_methods(["GET"])
def admin_detail(request, slug):
    template = 'profile/admin/complaint/detail.html'
    try:
        complaint = Complaint.objects.get(slug=slug)
        complaint.read_status=True
        complaint.save()
    except Complaint.DoesNotExist:
        complaint = None
    context = {
        'title' : 'Pengaduan' if complaint != None else 'TIDAK DITEMUKAN',
        'complaint' : complaint,
    }
    return render(request, template, context)

@login_required
@is_verified()
@require_http_methods(["POST"])
def reply(request):
    if request.method == 'POST':
        try:
            complaint = Complaint.objects.get(slug=request.POST.get('slug'))
            message = get_template("profile/email/complaint_reply.html").render({
                'name': complaint.name,
                'subject': complaint.subject,
                'message': complaint.message,
                'reply' : request.POST.get('balasan'),
            })
            connection = get_connection(host=settings.EMAIL_HOST, 
                                        port=settings.EMAIL_PORT, 
                                        username=settings.EMAIL_HOST_USER_PENGADUAN, 
                                        password=settings.EMAIL_HOST_PASSWORD_PENGADUAN, 
                                        use_tls=settings.EMAIL_USE_TLS)
            mail = EmailMessage(
                subject=f"Balasan terhadap pengaduan: {complaint.subject}",
                body=message,
                to=[
                    complaint.email,
                ],
                connection=connection,
            )
            mail.content_subtype = "html"
            mail.send()

            complaint.reply_status = True
            complaint.save()

            messages.success(request, 'Balasan anda berhasil dikirim.')
            return redirect('profile:admin_complaint_detail', slug=complaint.slug)
            
        except:
            messages.success(request, 'Balasan anda gagal dikirim.')
            return redirect('profile:complaint')

@login_required
@is_verified()
def softDelete(request, slug):
    message = ''
    try:
        sekarang = timezone.now()
        complaint = Complaint.objects.get(slug=slug)
        complaint.deleted_at = sekarang
        complaint.save()
        message = 'success'
    except Complaint.DoesNotExist:
        message = 'error'

    context = {
            'message' : message,
        }

    return HttpResponse(context)

@login_required
@is_verified()
def permanentDelete(request, slug):
    message = ''
    try:
        complaint = Complaint.objects.get(slug=slug)
        complaint.delete()
        message = 'success'
    except Complaint.DoesNotExist:
        message = 'error'

    context = {
            'message' : message,
        }

    return HttpResponse(context)
    
@login_required
@is_verified()
def restore(request, slug):
    message = ''
    try:
        complaint = Complaint.objects.get(slug=slug)
        complaint.deleted_at = None
        complaint.save()
        message = 'success'
    except Complaint.DoesNotExist:
        message = 'error'

    context = {
            'message' : message,
        }

    return HttpResponse(context)

rizq_sanjaya_app/templates/profile/news/detail_blog.html
{% extends 'profile/news/base_detail_blog.html' %}
{% load static %}
{% block main %}
<div role="main" class="main" id="main">

    <section class="page-header page-header-modern bg-color-light-scale-1 page-header-lg">
        <div class="container">
            <div class="row">
                <!-- <div class="col-md-12 align-self-center p-static order-2 text-center">
                    <h1 class="font-weight-bold text-dark">Right Sidebar</h1>
                </div> -->
                <div class="col-md-12 align-self-center order-1">
                    <ul class="breadcrumb d-block text-center">
                        <li><a href="{% url 'profile:home' %}">Home</a></li>
                        <li class="active">Informasi</li>
                    </ul>
                </div>
            </div>
        </div>
    </section>

    <div class="container pt-3 pb-2">

        <div class="row pt-2">
            <div class="col-lg-9">
                <img style="width: 100%;" src="{{news.thumbnail.url}}" alt="Device">
                <br>
                <h2 class="font-weight-normal text-7 mb-2"><strong class="font-weight-extra-bold">{{news.title}}</strong></h2>
                <p class="text-uppercase text-color-default text-1 my-2 pb-1">
                    <time pubdate datetime="2022-01-10"><i class="far fa-clock"></i> {{ news.created_at|date:"d M Y" }}</time> 
                    <span class="opacity-3 d-inline-block px-2">|</span>
                    <i class="far fa-eye"></i> 
                    Dilihat {{ news.seen }} kali
                    <span class="opacity-3 d-inline-block px-2">|</span>
                    <i class="far fa-user-circle"></i> 
                    {{ news.created_by.first_name }} {{ news.created_by.last_name }}
                </p>
                <div class="news-details-view">
                    {{news.content | safe}}
                </div>
            </div>

            <div class="col-lg-3 mt-4 mt-lg-0">
                <aside class="sidebar">
                    <h5 class="font-weight-semi-bold">Categories</h5>
                    <ul class="nav nav-list flex-column mb-5">
                        {% for dt in cats%}
                            <li><a href="{% url 'profile:news_by_category' jenis='id' slug=dt.slug %}" class="{% if news.category_id == dt.id %}active{% endif %}">{{dt.nama}}<span class="icon-right-arrow-angle"></span></a></li>
                        {% endfor %}
                        
                        <!-- <li class="nav-item">
                            <a class="nav-link active" href="#">Photos (4)</a>
                            <ul>
                                <li class="nav-item"><a class="nav-link" href="#">Animals</a></li>
                                <li class="nav-item"><a class="nav-link active" href="#">Business</a></li>
                                <li class="nav-item"><a class="nav-link" href="#">Sports</a></li>
                                <li class="nav-item"><a class="nav-link" href="#">People</a></li>
                            </ul>
                        </li> -->
                        <!-- <li class="nav-item"><a class="nav-link" href="#">Videos (3)</a></li>
                        <li class="nav-item"><a class="nav-link" href="#">Lifestyle (2)</a></li>
                        <li class="nav-item"><a class="nav-link" href="#">Technology (1)</a></li> -->
                    </ul>
                    
                    
                    
                    <div class="tabs tabs-dark mb-4 pb-2">
                        <ul class="nav nav-tabs">
                            <li class="nav-item"><a class="nav-link show active text-1 font-weight-bold text-uppercase" href="#popularPosts" data-bs-toggle="tab">Popular</a></li>
                            <li class="nav-item"><a class="nav-link text-1 font-weight-bold text-uppercase" href="#recentPosts" data-bs-toggle="tab">Recent</a></li>
                        </ul>
                        <div class="tab-content">
                            <div class="tab-pane active" id="popularPosts">
                                <ul class="simple-post-list">
                                    {% for dt in favs %}
                                    <li>
                                        <div class="post-image">
                                            <div class="img-thumbnail img-thumbnail-no-borders d-block">
                                                <a href="{% url 'profile:news_detail' slug=news.slug %}">
                                                    <img src="{{dt.thumbnail.url}}" width="50" height="50" alt="">
                                                </a>
                                            </div>
                                        </div>
                                        <div class="post-info">
                                            <a href="{% url 'profile:news_detail' slug=news.slug %}" style="color: black;">{{dt.title}}</a>
                                            <div class="post-meta">
                                                <i class="far fa-clock"></i> {{ dt.created_at|date:"d M Y" }}
                                            </div>
                                        </div>
                                    </li>
                                    {% endfor %}
                                </ul>
                            </div>
                            <div class="tab-pane" id="recentPosts">
                                <ul class="simple-post-list">
                                    {% for dt in recent %}
                                    <li>
                                        <div class="post-image">
                                            <div class="img-thumbnail img-thumbnail-no-borders d-block">
                                                <a href="{% url 'profile:news_detail' slug=news.slug %}">
                                                    <img src="{{dt.thumbnail.url}}" width="50" height="50" alt="">
                                                </a>
                                            </div>
                                        </div>
                                        <div class="post-info">
                                            <a href="{% url 'profile:news_detail' slug=news.slug %}" style="color: black;">{{dt.title}}</a>
                                            <div class="post-meta">
                                                <i class="far fa-clock"></i> {{ dt.created_at|date:"d M Y" }}
                                            </div>
                                        </div>
                                    </li>
                                    {% endfor %}
                                </ul>
                            </div>
                        </div>
                    </div>
                    <!-- <div class="sidebar__single sidebar__tag wow fadeInUp animated animated animated"
                    data-wow-delay="0.4s" data-wow-duration="1200m">
                        <div class="title">
                            <h2>Tags</h2>
                        </div>
                        <ul class="sidebar__tag-list">
                        {% for tag in news.tags.all %}
                            <li><a href="{% url 'profile:tags' jenis='news' slug=tag.slug %}" style="color: black;">#{{ tag.name }}</a></li>
                        {% endfor %}
                        </ul>
                    </div> -->
                    <h5 class="font-weight-semi-bold pt-4">About Us</h5>
                    <p>{{ about.deskripsi }}</p>
                </aside>
            </div>
        </div>

    </div>

</div>
{% endblock main %}